#ifndef __PING_H
#define __PING_H

//#include "..\types.h"

#include "wizchip_conf.h"

#define BUF_LEN 32
#define PING_REQUEST 8
#define PING_REPLY 0
#define PING_REQUEST_V6 128
#define PING_REPLY_V6 129
#define CODE_ZERO 0

#define PING6_UPPER_PKT_LEN 40


#define SOCKET_ERROR 1
#define TIMEOUT_ERROR 2
#define SUCCESS 3
#define REPLY_ERROR 4
#define PING_DEBUG

typedef struct pingmsg
{
  uint8_t  Type;            // 0 - Ping Reply, 8 - Ping Request
  uint8_t  Code;            // Always 0
  int16_t  CheckSum;        // Check sum
  int16_t  ID;              // Identification
  int16_t  SeqNum;          // Sequence Number
  int8_t   Data[BUF_LEN];   // Ping Data  : 1452 = IP RAW MTU - sizeof(Type+Code+CheckSum+ID+SeqNum)
} PINGMSGR;

uint8_t ping_auto   (uint8_t sn, uint8_t *addr);
uint8_t ping_request(uint8_t sn, uint8_t *addr);
uint8_t ping_reply  (uint8_t s, uint8_t *addr,  uint32_t rlen);
uint16_t checksum   (uint8_t *data_buf, uint16_t len);
uint16_t htons      (uint16_t hostshort);
#endif
